<?php
/**
 * GAzieCart Controller for GAzie Cart Component
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 * @link http://docs.joomla.org/Developing_a_Model-View-Controller_Component_-_Part_4
 * @license     GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/**
 * GAzieCart GAzieCart Controller
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class GAzieCartsControllerGAzieCart extends GAzieCartsController
{
    /**
     * constructor (registers additional tasks to methods)
     * @return void
     */
    function __construct()
    {
        parent::__construct();

        // Register Extra tasks
        $this->registerTask( 'add'  ,   'edit' );
    }

    /**
     * display the edit form
     * @return void
     */
    function edit()
    {
        JRequest::setVar( 'view', 'gaziecart' );
        JRequest::setVar( 'layout', 'form'  );
        JRequest::setVar('hidemainmenu', 1);

        parent::display();
    }

    /**
     * save a record (and redirect to main page)
     * @return void
     */
    function save()
    {
        $model = $this->getModel('gaziecart');

        if ($model->store($post)) {
            $msg = JText::_( 'Configurazione di GAzieCart Salvata!' );
        } else {
            $msg = JText::_( 'Errore nel Savataggio della Configurazione di GAzieCart' );
        }

        // Check the table in so it can be edited.... we are done with it anyway
        $link = 'index.php?option=com_gaziecart';
        $this->setRedirect($link, $msg);
    }

    /**
     * remove record(s)
     * @return void
     */
    function remove()
    {
        $model = $this->getModel('gaziecart');
        if(!$model->delete()) {
            $msg = JText::_( 'Errore: Una o pi&ugrave; configurazioni di GAzieCarts non possono essere cancellate!' );
        } else {
            $msg = JText::_( 'Parametro di configurazione di GazieCart(s) Cancellato' );
        }

        $this->setRedirect( 'index.php?option=com_gaziecart', $msg );
    }

    /**
     * cancel editing a record
     * @return void
     */
    function cancel()
    {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_gaziecart', $msg );
    }
}