<?php
/* $Id: lib.function.php,v 1.17 2011/01/01 11:07:46 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2011 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/

class magazzForm extends GAzieForm
{
    function selItem($name,$val,$strSearch='',$mesg,$val_hiddenReq='',$class='FacetSelect')
    {
       global $gTables,$admin_aziend;
       if ($admin_aziend['artsea'] == 'B'){        //ricerca per codice a barre
           $field = 'barcode';
       } elseif ($admin_aziend['artsea'] == 'D') { //ricerca per descrizione
           $field = 'descri';
       } else {                   //ricerca per codice (default)
           $field = 'codice';
       }
       if (!empty($val)) { //vengo da una modifica della precedente select case quindi non serve la ricerca
            $item=gaz_dbi_get_row($gTables['artico'],'codice',$val);
            echo "\t<input type=\"hidden\" name=\"$name\" value=\"$val\">\n";
            echo "\t<input type=\"hidden\" name=\"search[$name]\" value=\"".$item[$field]."\">\n";
            echo "\t<input type=\"submit\" value=\"".$item['codice']." - ".$item['descri']."\" name=\"change\" onclick=\"this.form.$name.value=''; this.form.hidden_req.value='change';\" title=\"$mesg[2]\">\n";
       } else {
          if (strlen($strSearch) >= 1) { //sto ricercando un nuovo articolo
            $item = gaz_dbi_dyn_query("codice,descri,barcode", $gTables['artico'],$field." LIKE '$strSearch%'","codice ASC, descri DESC");
            echo "\t<select name=\"$name\" class=\"FacetSelect\" onchange=\"this.form.hidden_req.value='$name'; this.form.submit();\">\n";
            echo "<option value=\"0\"> ---------- </option>";
            if (gaz_dbi_num_rows($item) > 0) {
                  while ($r = gaz_dbi_fetch_array($item)) {
                        $selected = '';
                        if ($r['codice'] == $val) {
                            $selected = "selected";
                        }
                        echo "\t\t <option value=\"".$r['codice']."\" $selected >".$r['codice']." - ".$r["descri"]."</option>\n";
                  }
                  echo "\t </select>\n";
             } else {
                  $msg = $mesg[0];
             }
        } else {
                 $msg = $mesg[1];
                 echo "\t<input type=\"hidden\" name=\"$name\" value=\"$val\">\n";
        }
        echo "\t<input type=\"text\" name=\"search[$name]\" value=\"".$strSearch."\" maxlength=\"15\" size=\"9\" class=\"FacetInput\">\n";
        if (isset($msg)) {
            echo "<input type=\"text\" style=\"color: red; font-weight: bold;\" size=\"".strlen($msg)."\" disabled value=\"$msg\">";
        }
        echo "\t<input type=\"image\" align=\"middle\" name=\"search_str\" src=\"../../library/images/cerbut.gif\">\n";
      }
    }

    function selectCaumag($val,$operat=-1,$empty=false,$val_hiddenReq='',$class='FacetSelect')
    {
        global $gTables;
        $refresh ='';
        if (!empty($val_hiddenReq)) {
            $refresh = "onchange=\"this.form.hidden_req.value='caumag'; this.form.submit();\"";
        }
        $query = "SELECT * FROM ".$gTables['caumag']." WHERE clifor = -1 AND operat = $operat";
        echo "\t <select name=\"caumag\" class=\"$class\" $refresh >\n";
        if ($empty) {
            echo "\t\t <option value=\"\">---------</option>\n";
        }
        $result = gaz_dbi_query($query);
        while ($r = gaz_dbi_fetch_array($result)) {
            $selected = '';
            if($r['codice'] == $val) {
               $selected = "selected";
            }
            echo "\t\t <option value=\"".$r['codice']."\" $selected >".$r['descri']."</option>\n";
        }
        echo "\t </select>\n";
    }

    function getOperators()  // Creo l'array associativo degli operatori dei documenti
    {
        return array ("VCO" => -1,"DDT" => -1,"FAD" => -1,"FAI" => -1,"FAP" => -1,"FNC" => 1,"FND" => 0,
                      "DDR" => -1,"DDL" => -1,"AFA" => 1,"ADT" => 1,"AFC" => -1, "VPR" => -1, "VOR" => -1, "VOW" => -1);
    }

    function getStockEvalMethod()  // Prendo il metodo di valorizzazione del magazzino impostato in configurazione azienda
    {
      global $gTables;
      $enterprise = gaz_dbi_get_row($gTables['aziend'],'codice',$_SESSION['enterprise_id']);
      return $enterprise['stock_eval_method'];
    }

    function getLastCost($item_code,$decimal_price)  // Prendo il costo dall'ultimo movimento d'aquisto
    {
      global $gTables;
      $rs_last_cost = gaz_dbi_dyn_query("*", $gTables['movmag'], " artico = '$item_code' AND tipdoc LIKE 'A%' AND operat = 1 ","datreg DESC, id_mov DESC",0,1);
      $last_cost = gaz_dbi_fetch_array($rs_last_cost);
      if ($last_cost) {
         return CalcolaImportoRigo(1,$last_cost['prezzo'],array($last_cost['scochi'],$last_cost['scorig']),$decimal_price);
      } else {
         return 0;
      }
    }

    function ctrlMovYearsAfter($year,$item_code)  // Controllo che non ci siano movimenti negli anni successivi
    {
      global $gTables;
      $rs_years_after = gaz_dbi_dyn_query("*", $gTables['movmag'], "YEAR(datreg) > $year AND artico = '$item_code' AND tipdoc LIKE 'A%' AND operat = 1 ","datreg DESC, id_mov DESC",0,1);
      $years_after = gaz_dbi_fetch_array($rs_years_after);
      if ($years_after) {
          return false;   // non si pu aggiornare il valore dell'esistente perch ci sono movimenti su anni successivi
      } else {
          return true;
      }
    }

    function updateStockValue($item_code,$year=null,$stock_eval_method=null)    //Aggiorno il valore dell'esistente
    {
     global $gTables,$admin_aziend;

     if (!$year){
        $year=date("Y");
     }
     $year = substr($year,0,4);
     if (!$stock_eval_method){
        $stock_eval_method = $this->getStockEvalMethod();
     }
     $new_value = null;
     $last_cost = 'last_cost';
     $where = "YEAR(datreg) = $year AND artico = '$item_code' AND operat = 1 AND caumag < 99";
     if ($this->ctrlMovYearsAfter($year,$item_code)) { //controllo che non ci siano movimenti in anni successivi
        switch ($stock_eval_method) { //calcolo il nuovo valore in base al metodo scelto in configurazione azienda
            case "0": //standard
            case "3": // FIFO
                 $rs_last_movmag = gaz_dbi_dyn_query("*", $gTables['movmag'], $where,"datreg DESC, id_mov DESC",0,1);
                 $last_movmag = gaz_dbi_fetch_array($rs_last_movmag);
                 if ($last_movmag) {
                    $new_value = CalcolaImportoRigo(1,$last_movmag['prezzo'],array($last_movmag['scochi'],$last_movmag['scorig']),$admin_aziend['decimal_price']);
                 }
            break;
            case "1": // WMA
                 $rs_year_movmag = gaz_dbi_dyn_query("SUM((prezzo-prezzo*(scochi+(scorig-scochi*scorig/100))/100)*quanti*operat) AS value_sum , SUM(quanti*operat) AS quanti_sum ", $gTables['movmag'], "YEAR(datreg) = $year AND artico = '$item_code' AND operat = 1 GROUP BY artico","datreg DESC, id_mov DESC");
                 $year_movmag = gaz_dbi_fetch_array($rs_year_movmag);
                 if ($year_movmag) {
                    $new_value = $year_movmag['value_sum']/$year_movmag['quanti_sum'];
                 }
            break;
            case "2": // LIFO
                 $rs_first_movmag = gaz_dbi_dyn_query("*", $gTables['movmag'], $where,"datreg ASC, id_mov ASC",0,1);
                 $first_movmag = gaz_dbi_fetch_array($rs_first_movmag);
                 if ($first_movmag) {
                     $new_value = CalcolaImportoRigo(1,$first_movmag['prezzo'],array($first_movmag['scochi'],$first_movmag['scorig']),$admin_aziend['decimal_price']);
                 }
            break;
            default:
              $new_value = null;
        }
        $last_cost = $this->getLastCost($item_code,$admin_aziend['decimal_price']);
     }
     if ($new_value) {
        gaz_dbi_query ("UPDATE ".$gTables['artico']." SET valore = esiste * $new_value, last_cost = $last_cost WHERE `codice` = '".$item_code."';");
     }
     return $new_value;
    }

    function uploadMag($id_rigo_doc=0,$tipdoc,$numdoc,$seziva,$datdoc,$clfoco,$sconto_chiusura,$caumag,$codart,$quantita,$prezzo,$sconto_rigo,$id_movmag=0,$stock_eval_method=null,$data_from_admin_mov=false)  // su id_rigo_doc 0 per inserire 1 o + per fare l'upload 'DEL' per eliminare il movimento
    {
        // in $data_from_admin_mov  ci sono i dati in pi provenienti da admin_movmag (desdoc,operat, id_rif)
        global $gTables, $money,$admin_aziend;
        $docOperat = $this->getOperators();
        if ($tipdoc == 'FAD'){  // per il magazzino una fattura differita  come dire DDT
            $tipdoc = 'DDT';
        }
        if (substr($tipdoc,0,1) == 'A' or $tipdoc == 'DDR' or $tipdoc == 'DDL'){ //documento di acquisto
          require("../../modules/acquis/lang.".$admin_aziend['lang'].".php");
          $desdoc=$strScript['admin_docacq.php'][0][$tipdoc];
        } else { //documento di vendita
          require("../../modules/vendit/lang.".$admin_aziend['lang'].".php");
          $desdoc=$strScript['admin_docven.php'][0][$tipdoc];
        }
        if (substr($tipdoc,0,1) == 'D' || $tipdoc == 'VCO'){
          $desdoc .= " n.".$numdoc;
        } else {
          $desdoc .= " n.".$numdoc." prot.".$seziva;
        }
        $new_caumag = gaz_dbi_get_row($gTables['caumag'],'codice',$caumag);
        $operat = $new_caumag['operat'];
        if (!$data_from_admin_mov){         // se viene da un documento
           $datreg = $datdoc;               // la data di registrazione coincide con quella del documento
           $operat = $docOperat[$tipdoc];    // e la descrizione la ricavo dal tipo documento
        } else {                            // se  stato passato l'array dei dati
           $datreg = $data_from_admin_mov['datreg']; // prendo la descrizione e l'operatore da questo
           $operat = $data_from_admin_mov['operat'];
           $desdoc = $data_from_admin_mov['desdoc'];
        }
        $row_movmag = array('caumag'=>$caumag,
                            'operat'=>$operat,
                            'datreg'=>$datreg,
                            'tipdoc'=>$tipdoc,
                            'desdoc'=>$desdoc,
                            'datdoc'=>$datdoc,
                            'clfoco'=>$clfoco,
                            'scochi'=>$sconto_chiusura,
                            'id_rif'=>$id_rigo_doc,
                            'artico'=>$codart,
                            'quanti'=>$quantita,
                            'prezzo'=>$prezzo,
                            'scorig'=>$sconto_rigo );
        if ($id_movmag==0) {                             // si deve inserire un nuovo movimento
           movmagInsert($row_movmag);
           $ultimo_id_mm = gaz_dbi_last_id(); //id del rigo movimento magazzino
           gaz_dbi_put_row($gTables['rigdoc'], 'id_rig', $id_rigo_doc, 'id_mag', gaz_dbi_last_id());
           $upd_art_exist_value = $quantita*$operat*$new_caumag['upesis'];
        } elseif ($id_rigo_doc==='DEL') {                 // si deve eliminare un movimento esistente
            $old_movmag = gaz_dbi_get_row($gTables['movmag'],'id_mov',$id_movmag);
            $old_caumag = gaz_dbi_get_row($gTables['caumag'],'codice',$old_movmag['caumag']);
            gaz_dbi_del_row($gTables['movmag'], 'id_mov', $id_movmag);
            $upd_art_exist_value =  - $old_movmag['quanti']*$old_movmag['operat']*$old_caumag['upesis'];
            $codart = $old_movmag['artico'] ;
        } else {   // si deve modificare un movimento esistente
            $old_movmag = gaz_dbi_get_row($gTables['movmag'],'id_mov',$id_movmag);
            $old_caumag = gaz_dbi_get_row($gTables['caumag'],'codice',$old_movmag['caumag']);
            $id = array('id_mov',$id_movmag);
            if (!isset($new_caumag['operat'])){
               $new_caumag['operat'] = 0;
            }
            if (!isset($old_caumag['operat'])){
               $old_caumag['operat'] = 0;
            }
            movmagUpdate($id,$row_movmag);
            // detraggo il valore del movimento precedente dall'esistente dell'articolo precedente
            $upd_old_art_exist_value =  $old_movmag['quanti']*$old_movmag['operat']*$old_caumag['upesis'];
            gaz_dbi_query ("UPDATE ".$gTables['artico']." SET esiste = esiste - ".$upd_old_art_exist_value." WHERE `codice` = '".$old_movmag['artico']."';");
            // poi aggiungo il nuovo
            $upd_art_exist_value = $quantita*$operat*$new_caumag['upesis'];
        }
        gaz_dbi_query ("UPDATE ".$gTables['artico']." SET esiste = esiste + ".$upd_art_exist_value." WHERE `codice` = '".$codart."';");
        $this->updateStockValue($codart,$datreg,$stock_eval_method);
    }
}
?>