<?php
/*$Id: view.html.php,v 1.5 2010/12/06 14:57:54 devincen Exp $
 --------------------------------------------------------------------------
                            Gazie - Gestione Azienda
    Copyright (C) 2004-2010 - Antonio De Vincentiis Montesilvano (PE)
                                (www.devincentiis.it)
                        <http://gazie.sourceforge.net>
 --------------------------------------------------------------------------
    Questo programma e` free software;   e` lecito redistribuirlo  e/o
    modificarlo secondo i  termini della Licenza Pubblica Generica GNU
    come e` pubblicata dalla Free Software Foundation; o la versione 2
    della licenza o (a propria scelta) una versione successiva.

    Questo programma  e` distribuito nella speranza  che sia utile, ma
    SENZA   ALCUNA GARANZIA; senza  neppure  la  garanzia implicita di
    NEGOZIABILITA` o di  APPLICABILITA` PER UN  PARTICOLARE SCOPO.  Si
    veda la Licenza Pubblica Generica GNU per avere maggiori dettagli.

    Ognuno dovrebbe avere   ricevuto una copia  della Licenza Pubblica
    Generica GNU insieme a   questo programma; in caso  contrario,  si
    scriva   alla   Free  Software Foundation,  Inc.,   59
    Temple Place, Suite 330, Boston, MA 02111-1307 USA Stati Uniti.
 --------------------------------------------------------------------------
*/
/**
 * GAzieCart View for GAzie Cart Component
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 * @link http://dev.joomla.org/component/option,com_jd-wiki/Itemid,31/id,tutorials:components/
 * @license     GNU/GPL
 */

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the GAzieCartWorld Component
 *
 * @package     Joomla.Tutorials
 * @subpackage  Components
 */
class GAzieCartViewSendmail extends JView
{
    function display($tpl = null)
    {
        global $mainframe;

        $head_msg = $this->get( 'TopMessage' );
        $this->assignRef( 'head_msg',   $head_msg );
        $foot_msg = $this->get( 'FootMessage' );
        $this->assignRef( 'foot_msg',   $foot_msg );
        $tax = $this->get('TaxRate');
        $mail = $this->get('SendMail');
        $data = $this->get('CartData');
        $this->assignRef( 'cart_data', $data);
        if ($data['captcha']==$data['key']) {  // captcha is correct
            $mailer =& JFactory::getMailer();
            $config =& JFactory::getConfig();
            $sender = array( $config->getValue( 'config.mailfrom' ),
                             $config->getValue( 'config.fromname' ) );
            $recipient = array($mail);
            $user =& JFactory::getUser();
            if (!empty($user->email)){
                $recipient[] = $user->email;
            }
            if (!empty($data['email'])){
                $recipient[] = $data['email'] ;
            }
            $mailer->addRecipient($recipient);
            $order_n=date("YmdHis"); // subject
            $mailer->setSubject('Ordine n.'.$order_n);
            $mailer->isHTML(true);
            $body   = '<h2>Ordine n.'.$order_n.'</h2>';
            $body  .= '<div>Ordinante: '.$data['name'].'</div>';
            $body  .= '<table width="100%">
            <th></th><th>Codice</th><th>Descrizione</th><th align="right">Q.t&agrave;</th><th align="center">U.M.</th><th></th><th align="right">Prezzo</th><th align="right">Importo</th><th align="right">IVA</th>';
            $t=0.00;
            $xml='<?xml version="1.0" encoding="utf-8" ?>'."\n<web_order>\n";
            $xml .= "\t<head>\n\t\t<number>".$order_n."</number>\n\t\t<name>".$data['name']."</name>\n\t\t<text>".$data['text']."</text>\n\t</head>\n";
            $vat=0;
            foreach($data['cart_data'] as $v) {
                $i=round($v['quantity']*$v['price'],2);
                $t+=$i;
                $body .= '<tr><td><img src="cid:'.$v['name'].'_id" alt="'.$v['name'].'" width="50" /></td>
                          <td>'.$v['name'].'</td>
                          <td>'.$v['description'].'</td>
                          <td align="right">'.$v['quantity'].'</td>
                          <td align="center">'.$v['mu'].'</td>
                          <td align="center">x</td>
                          <td align="right">'.$v['price'].'</td>
                          <td align="right">'.number_format($i,2,'.',' ').'</td>
                          <td align="right">'.$v['taxrate'].'%</td></tr>';
                // Add embedded image
                $mailer->AddEmbeddedImage( JPATH_COMPONENT.DS.'images'.DS.'artico'.DS.$v['name'].'.png', $v['name'].'_id', $v['name'].'.png', 'base64', 'image/png' );
                $xml .= "\t<row>\n\t\t<codice>".$v['name']."</codice>\n\t\t<descri>".$v['description']."</descri>\n\t\t<quanti>".$v['quantity']."</quanti>\n\t\t<unimis>".$v['mu']."</unimis>\n\t\t<prezzoweb>".$v['price']."</prezzoweb>\n\t\t<taxrate>".$v['taxrate']."</taxrate>\n\t</row>\n";
                $vat+=$i*$v['taxrate']/100;
            }
            $vat=round($vat,2);
            $body .= '<tr><td colspan="6"></td><td><h4 style="text-align:right;">Totale dell\'ordine: </h4></td><td><h4 style="text-align:right;">'.number_format($t,2,',','.')."</h4></td></tr>\n";
            $body .= '<tr><td colspan="6"></td><td><h4 style="text-align:right;">I.V.A. : </h4></td><td><h4 style="text-align:right;">'.number_format($vat,2,',','.')."</h4></td></tr>\n";
            $body .= '<tr><td colspan="6"></td><td><h4 style="text-align:right;">Totale da pagare: </h4></td><td><h4 style="text-align:right;">'.number_format($t+$vat,2,',','.')."</h4></td></tr>\n";
            $body .= '</table>';
            $body .= '<div>'.$data['text'].'</div>';
            $xml  .= '</web_order>';
            $mailer->setBody($body);
            // File attached
            $mailer->addStringAttachment($xml,'gaziecart.xml','base64','text/xml');
            $send =& $mailer->Send();
            if ( $send !== true ) {
                $uri        = JFactory::getURI();
                $return     = $uri->toString();
                $url  = 'index.php?option=com_gaziecart&view=checkout';
                $url .= '&return='.base64_encode($return);
                $mainframe->redirect($url, JText::_('Error sending email: ' . $send->message) );
            } else {
                $body='<h1>Trasmissione avvenuta con successo.<br />La contatteremo per la conferma e per tenerla informata sui tempi di consegna.</h1>'.$body;
                $this->assignRef( 'send_result',$body);
                // annullo i dati in sessione dell'ordine trasmesso, ma lascio il nome e l'email
                $session =& JFactory::getSession();
                $session->set("cart_data",'');
                $session->set("text",'');
                // Add JS for empty simpleCart cookie
                $document =& JFactory::getDocument();
                $document->addScript('components/com_gaziecart/simplecart/simpleCart.js');
                $script = "document.onload = eraseCookie('simpleCart');";
                $document->addScriptDeclaration($script);
            }
        } else {     // captcha incorrect
            $uri        = JFactory::getURI();
            $return     = $uri->toString();
            $url  = 'index.php?option=com_gaziecart&view=checkout';
            $url .= '&return='.base64_encode($return);
            $mainframe->redirect($url, JText::_('Hai sbagliato a fare la somma!') );
        }
        parent::display($tpl);

    }
}
?>